# road_func.h File Reference

Functions related to roads. More...

`#include "core/bitmath_func.hpp"`
`#include "road_type.h"`
`#include "direction_type.h"`
`#include "company_type.h"`
`#include "tile_type.h"`

Go to the source code of this file.

## Functions
static bool | IsValidRoadType (RoadType rt)
| Whether the given roadtype is valid.
static bool | AreValidRoadTypes (RoadTypes rts)
| Are the given bits pointing to valid roadtypes?
static RoadTypes | RoadTypeToRoadTypes (RoadType rt)
| Maps a RoadType to the corresponding RoadTypes value.
static RoadTypes | ComplementRoadTypes (RoadTypes r)
| Returns the RoadTypes which are not present in the given RoadTypes.
static RoadBits | ComplementRoadBits (RoadBits r)
| Calculate the complement of a RoadBits value.
static RoadBits | MirrorRoadBits (RoadBits r)
| Calculate the mirrored RoadBits.
static RoadBits | RotateRoadBits (RoadBits r, DiagDirDiff rot)
| Calculate rotated RoadBits.
static bool | IsStraightRoad (RoadBits r)
| Check if we've got a straight road.
static RoadBits | DiagDirToRoadBits (DiagDirection d)
| Create the road-part which belongs to the given DiagDirection.
static RoadBits | AxisToRoadBits (Axis a)
| Create the road-part which belongs to the given Axis.
bool | HasRoadTypesAvail (const CompanyID company, const RoadTypes rts)
| Finds out, whether given company has all given RoadTypes available.
bool | ValParamRoadType (const RoadType rt)
| Validate functions for rail building.
RoadTypes | GetCompanyRoadtypes (const CompanyID company)
| Get the road types the given company can build.
void | UpdateLevelCrossing (TileIndex tile, bool sound=true)
| Sets correct crossing state.

## Detailed Description

Functions related to roads.

Definition in file road_func.h.

## Function Documentation

static bool AreValidRoadTypes | ( | RoadTypes | rts | ) | `[inline, static]`

Are the given bits pointing to valid roadtypes?

Parameters:

  | rts | the roadtypes to check for validness

Returns:
  true if and only if valid

Definition at line 36 of file road_func.h.

References HasBit(), ROADTYPE_ROAD, and ROADTYPE_TRAM.

Referenced by CmdBuildBridge(), CmdBuildRoadStop(), and CmdBuildTunnel().

static RoadBits AxisToRoadBits | ( | Axis | a | ) | `[inline, static]`

Create the road-part which belongs to the given Axis.

This function returns a RoadBits value which belongs to the given Axis.

Parameters:

  | a | The Axis

Returns:
  The result RoadBits which the selected road-part set

Definition at line 145 of file road_func.h.

References AXIS_X, ROAD_X, and ROAD_Y.

Referenced by CmdBuildLongRoad(), CmdBuildRoad(), CmdRemoveLongRoad(), GetAnyRoadBits(), and RoadFindPathToDest().

static RoadBits ComplementRoadBits | ( | RoadBits | r | ) | `[inline, static]`

Calculate the complement of a RoadBits value.

Simply flips all bits in the RoadBits value to get the complement of the RoadBits.

Parameters:

  | r | The given RoadBits value

Returns:
  the complement

Definition at line 76 of file road_func.h.

References ROAD_ALL.

Referenced by CmdBuildRoad(), and RemoveRoad().

static RoadTypes ComplementRoadTypes | ( | RoadTypes | r | ) | `[inline, static]`

Returns the RoadTypes which are not present in the given RoadTypes.

This function returns the complement of a given RoadTypes.

Parameters:

  | r | The given RoadTypes

Returns:
  The complement of the given RoadTypes

Note:
  The unused value ROADTYPES_HWAY will be used, too.

Definition at line 61 of file road_func.h.

References ROADTYPES_ALL.

Referenced by RemoveRoad().

static RoadBits DiagDirToRoadBits | ( | DiagDirection | d | ) | `[inline, static]`

Create the road-part which belongs to the given DiagDirection.

This function returns a RoadBits value which belongs to the given DiagDirection.

Parameters:

  | d | The DiagDirection

Returns:
  The result RoadBits which the selected road-part set

Definition at line 131 of file road_func.h.

References ROAD_NW.

Referenced by AIBridge::_BuildBridgeRoad1(), AIBridge::_BuildBridgeRoad2(), AITunnel::_BuildTunnelRoad1(), AITunnel::_BuildTunnelRoad2(), CleanUpRoadBits(), CmdBuildLongRoad(), CmdBuildRoad(), CmdRemoveRoadStop(), GetAnyRoadBits(), GetTownRoadGridElement(), GrowTownAtRoad(), GrowTownInTile(), GrowTownWithBridge(), IsNeighborRoadTile(), and RoadFindPathToDest().

RoadTypes GetCompanyRoadtypes | ( | const CompanyID | company | ) |

Get the road types the given company can build.

Parameters:

  | company | the company to get the roadtypes for.

Returns:
  the road types.

Definition at line 112 of file road.cpp.

References _date, _settings_game, DAYS_IN_YEAR, EF_ROAD_TRAM, GameSettings::game_creation, HasBit(), GameCreationSettings::landscape, ROADTYPE_ROAD, ROADTYPE_TRAM, ROADTYPES_NONE, SetBit(), and VEH_ROAD.

Referenced by DoStartupNewCompany().

bool HasRoadTypesAvail | ( | const CompanyID | company,
|  | const RoadTypes | rts |
| ) |  |  |

Finds out, whether given company has all given RoadTypes available.

Parameters:

  | company | ID of company
  | rts | RoadTypes to test

Returns:
  true if company has all requested RoadTypes available

Definition at line 93 of file road.cpp.

References Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_company_pool >::GetIfValid(), IsGeneratingWorld(), OWNER_TOWN, and ROADTYPES_ROAD.

Referenced by CmdBuildBridge(), CmdBuildRoadStop(), CmdBuildTunnel(), AIRoad::IsRoadTypeAvailable(), and ValParamRoadType().

static bool IsStraightRoad | ( | RoadBits | r | ) | `[inline, static]`

Check if we've got a straight road.

Parameters:

  | r | The given RoadBits

Returns:
  true if we've got a straight road

Definition at line 117 of file road_func.h.

References ROAD_X, and ROAD_Y.

Referenced by CheckRoadSlope(), CmdBuildRoad(), and RemoveRoad().

static bool IsValidRoadType | ( | RoadType | rt | ) | `[inline, static]`

Whether the given roadtype is valid.

Parameters:

  | rt | the roadtype to check for validness

Returns:
  true if and only if valid

Definition at line 26 of file road_func.h.

References ROADTYPE_ROAD, and ROADTYPE_TRAM.

Referenced by CmdBuildLongRoad(), CmdBuildRoad(), CmdBuildRoadDepot(), and CmdRemoveLongRoad().

static RoadBits MirrorRoadBits | ( | RoadBits | r | ) | `[inline, static]`

Calculate the mirrored RoadBits.

Simply move the bits to their new position.

Parameters:

  | r | The given RoadBits value

Returns:
  the mirrored

Definition at line 89 of file road_func.h.

References GB().

Referenced by CheckRoadSlope(), CleanUpRoadBits(), CmdBuildRoad(), and RemoveRoad().

static RoadTypes RoadTypeToRoadTypes | ( | RoadType | rt | ) | `[inline, static]`

Maps a RoadType to the corresponding RoadTypes value.

Parameters:

  | rt | the roadtype to get the roadtypes from

Returns:
  the roadtypes with the given roadtype

Definition at line 47 of file road_func.h.

Referenced by AIRoad::_BuildRoadStationInternal(), AfterLoadVehicles(), AIBridge::BuildBridge(), AITunnel::BuildTunnel(), CmdBuildRoad(), CmdBuildRoadVeh(), AIRoad::GetNeighbourRoadCount(), AIStation::HasRoadType(), AIRoad::IsDriveThroughRoadStationTile(), AIRoad::IsRoadDepotTile(), AIRoad::IsRoadStationTile(), AIRoad::IsRoadTypeAvailable(), BuildRoadToolbarWindow::OnPlaceMouseUp(), BuildRoadToolbarWindow::OnPlacePresize(), RemoveRoad(), and ValParamRoadType().

static RoadBits RotateRoadBits | ( | RoadBits | r,
|  | DiagDirDiff | rot |
| ) |  |  | `[inline, static]`

Calculate rotated RoadBits.

Move the Roadbits clockwise til they are in their final position.

Parameters:

  | r | The given RoadBits value
  | rot | The given Rotation angle

Returns:
  the rotated

Definition at line 103 of file road_func.h.

References GB().

void UpdateLevelCrossing | ( | TileIndex | tile,
|  | bool | sound |
| ) |  |  |

Sets correct crossing state.

Parameters:

  | tile | tile to update
  | sound | should we play sound?

Precondition:
  tile is a rail-road crossing

Definition at line 1735 of file train_cmd.cpp.

References HasCrossingReservation(), HasVehicleOnPos(), MarkTileDirtyByTile(), TrainApproachingCrossing(), and TrainOnTileEnum().

Referenced by CmdBuildRoad(), CmdBuildSingleRail(), Train::Crash(), DeleteLastWagon(), and UnreserveRailTrack().

bool ValParamRoadType | ( | const RoadType | rt | ) |

Validate functions for rail building.

Parameters:

  | rt | road type to check.

Returns:
  true if the current company may build the road.

Definition at line 107 of file road.cpp.

References HasRoadTypesAvail(), and RoadTypeToRoadTypes().

Referenced by CmdBuildLongRoad(), CmdBuildRoad(), and CmdBuildRoadDepot().